#!/usr/local/bin/python
# -*- coding: utf-8 -*-

import ssl
import sys
import urllib2
import urllib
import json
import re
from bs4 import BeautifulSoup
from urlparse import parse_qsl

import xbmc
import xbmcaddon
import xbmcgui
import xbmcplugin

from resources import packer

_url = sys.argv[0]
_handle = int(sys.argv[1])
_addon = xbmcaddon.Addon()
_name = _addon.getAddonInfo('name')
_icon = _addon.getAddonInfo('icon')


def URL(action, link):
    u = _url + '?action=' + urllib2.quote(action)
    if link is not None:
        u += '&link=' + urllib2.quote(link)
    return u


MENU_ITEMS = []
DOMAIN = "https://ww1.123-movies.com"
UA = 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/40.0.2214.85 Safari/537.36'
MAIN_MENU = [
    ("Movies", URL('list', DOMAIN + '/movies')),
    # ("Top IMBd", URL('list', DOMAIN + '/topimdb')),
    ("TV Shows", URL('list', DOMAIN + '/series')),
    ("New Episodes", URL('list', DOMAIN + '/episodes/')),
    ("Genre", URL('menu', 'genre')),
    ("Country", URL('menu', 'country')),
    ("Search", URL('find', None))
]

SUBMENUS = {
    'genre': [
        ("Action", URL('list', DOMAIN + '/genre/action/')),
        ("Adventure", URL('list', DOMAIN + '/genre/adventure/')),
        ("Animation", URL('list', DOMAIN + '/genre/animation/')),
        ("Biography", URL('list', DOMAIN + '/genre/biography/')),
        ("Comedy", URL('list', DOMAIN + '/genre/comedy/')),
        ("Crime", URL('list', DOMAIN + '/genre/crime/')),
        ("Documentary", URL('list', DOMAIN + '/genre/documentary/')),
        ("Drama", URL('list', DOMAIN + '/genre/drama/')),
        ("Family", URL('list', DOMAIN + '/genre/family/')),
        ("Fantasy", URL('list', DOMAIN + '/genre/fantasy/')),
        ("History", URL('list', DOMAIN + '/genre/history/')),
        ("Horror", URL('list', DOMAIN + '/genre/horror/')),
        ("Musical", URL('list', DOMAIN + '/genre/musical/')),
        ("Mystery", URL('list', DOMAIN + '/genre/mystery/')),
        ("Romance", URL('list', DOMAIN + '/genre/romance/')),
        ("Sci-Fi", URL('list', DOMAIN + '/genre/sci-fi/')),
        ("Sport", URL('list', DOMAIN + '/genre/sport/')),
        ("Thriller", URL('list', DOMAIN + '/genre/thriller/')),
        ("War", URL('list', DOMAIN + '/genre/war/'))
    ],
    'country': [
        ("Asia", URL('list', DOMAIN + '/country/"asia/')),
        ("China", URL('list', DOMAIN + '/country/china/')),
        ("Euro", URL('list', DOMAIN + '/country/euro/')),
        ("France", URL('list', DOMAIN + '/country/france/')),
        ("HongKong", URL('list', DOMAIN + '/country/hong kong/')),
        ("India", URL('list', DOMAIN + '/country/india/')),
        ("International", URL('list', DOMAIN + '/country/international/')),
        ("Japan", URL('list', DOMAIN + '/country/japan/')),
        ("Korea", URL('list', DOMAIN + '/country/korea/')),
        ("Taiwan", URL('list', DOMAIN + '/country/taiwan/')),
        ("Thailand", URL('list', DOMAIN + '/country/thailand/')),
        ("United Kingdom", URL('list', DOMAIN + '/country/uk/')),
        ("United States", URL('list', DOMAIN + '/country/us/'))
    ]
}

VALID_SRC = {
    'https://gomostream.com/vid',
    'https://streamango.com/embed',
    'https://viduplayer.com/embed',
    'https://gounlimited.to/embed',
}


def new_menu_item(label, action, url, img=None, playable=False):
    item = xbmcgui.ListItem(label=label, thumbnailImage=img)
    if playable:
        item.setProperty('IsPlayable', 'true')
        item.setInfo('video', {})
        xbmcplugin.addDirectoryItem(_handle, URL(action, url), listitem=item)
    else:
        MENU_ITEMS.append((URL(action, url), item, True))
    return item


def make_soup(url, params=None, raw=False, headers=None, retry=True, redirects=0):
    xbmc.log("Requesting URL: " + url, 4)
    if params:
        paramsdata = urllib.urlencode(params)
        req = urllib2.Request(url, paramsdata)
    else:
        req = urllib2.Request(url)
    req.add_header('User-Agent', UA)
    for k, v in (headers or {}).items():
        req.add_header(k, v)
    try:
        resp = urllib2.urlopen(req, timeout=120)
        xbmc.log("Processing: " + resp.geturl(), 4)
        data = resp.read()
        result = data.decode('utf-8', 'ignore')
        if not raw:
            result = BeautifulSoup(result, "html.parser")
        resp.close()
        return result
    except urllib2.HTTPError, e:
        cookie = e.headers.get('set-cookie')
        if cookie:
            cookie = cookie.split(';')[0]
            headers = headers or {}
            headers['Cookie'] = cookie
            xbmc.log("Setting cookie: " + cookie, 4)
            make_soup(url, params, raw, headers=headers)
        raise e


def play_video(link):
    play_item = xbmcgui.ListItem(path=link)
    play_item.setInfo('video', {})
    for src in VALID_SRC:
        if link.startswith(src):
            data = make_soup(link, raw=True, headers={
                'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
                'Accept-Language': 'en-US,en;q=0.5',
                'Cookie': '__cfduid=',
                'DNT': '1',
                'Connection': 'keep-alive',
                'Upgrade-Insecure-Requests': '1',
                'Pragma': 'no-cache',
                'Cache-Control': 'no-cache'
            })
            data = data[data.index('eval(function(p,a,c,k,e,'):]
            data = data[:data.index('</script>')]
            if packer.detect(data):
                data = packer.unpack(data)
                urls = re.findall(r'(http|https)://([\w_-]+(?:(?:\.[\w_-]+)+))([\w.,@?^=%&:/~+#-]*[\w@?^=%&/~+#-])?', data)
                videos = filter(lambda x: x[-1].endswith('mp4'), urls)
                if len(videos) > 0:
                    url = videos[0][0] + '://' + videos[0][1] + videos[0][2]
                    xbmc.log("Found video file: " + url, 4)
                    play_item.setPath(url)
                else:
                    xbmc.log("No videos found!", 4)
            else:
                xbmc.log("Failed unpack js: " + link, 4)
            break
    else:
        xbmc.log("Attempting to play: " + link, 4)
    xbmcplugin.setResolvedUrl(_handle, True, listitem=play_item)


def process_list(url):
    soup = make_soup(url)
    videos = []
    mlist = soup.find('div', class_=['movies-list'])
    if mlist:
        videos += mlist.find_all('div', class_=['ml-item'])
    videos += soup.find_all('div', class_=['singleVideo'])
    xbmc.log("Found: %d videos" % len(videos), 4)
    for video in videos:
        try:
            title = video.find('a')['oldtitle']
            xbmc.log("Found: " + title, 4)

            tmp = video.find('span', class_='mli-quality')
            additional = None
            if tmp is not None:
                additional = tmp.getText()
            else:
                tmp = video.find('p', class_='seacsonInfo')
                if tmp is not None:
                    additional = tmp.find('span').getText() + " Season"

            if additional:
                title = '%s [COLOR red]%s[/COLOR]' % (title, additional)

            url = video.find('a')['href']
            item = new_menu_item(title, 'video', url)
            try:
                img_data = video.find('img')
                item.setThumbnailImage(img_data['data-original'] if 'data-original' in img_data else img_data['src'])
            except KeyError:
                pass

            info = video.find_all('div', class_=['jt-info'])
            year = info[1].getText().split('-')[0]
            plot = video.find('p', class_='f-desc').getText()
            info_labels = {'plot': plot}

            imdb = video.find('div', class_=['jt-imdb'])
            if imdb:
                rating = re.findall(r'(\d{2}.\d+|\d{2})', imdb.getText())
                if len(rating) > 0:
                    rating = float(rating[0])
                    if rating <= 10:
                        info_labels['rating'] = rating

            if str(year).isdigit():
                info_labels['year'] = year
            item.setInfo(type="video", infoLabels=info_labels)
        except ValueError:
            continue
    pagination = soup.find('ul', class_='pagination')
    if pagination is None:
        return
    pagination_a = pagination.find_all('a')
    current = pagination.find_all('li', class_='active')[-1].getText()
    next_url = pagination_a[-1]['href']
    total = pagination_a[-2].getText()
    xbmc.log("Next URL: " + next_url, 4)
    new_menu_item('[COLOR blue]Page %d out of %s[/COLOR]' % (int(current) + 1, total), 'list', next_url)


def process_video(url, play=False):
    print "Processing video page"
    soup = make_soup(url)
    source = soup.find('a', class_=['thumb', 'mvi-cover'])
    if source is None:  # TV Series page
        episodes = soup.find('div', class_='videosContainer').find_all('div', class_=['singleVideo'])
        for episode in episodes:
            title = episode.find('div', class_='tiptitle').getText()
            url = episode.find('a')['href']
            img = episode.find('img')['src']
            plot = episode.find('p', class_='f-desc').getText()
            item = new_menu_item(title, 'videoPlay', url, img=img)
            item.setInfo(type="video", infoLabels={'plot': plot})
        return
    soup = make_soup(source['href'])
    if not play:
        episodes = soup.find('div', class_=['espidoes_listings'])
        if episodes is not None:
            img = soup.find('div', class_='topdescriptionthumb').find('img')['src']
            for d in soup.find_all('div', class_='single_epsiode_row_left'):
                new_menu_item(d.getText(), 'video', d.find_next('a')['href'], img=img)
                #
                # plot = soup.find('div', class_='topdescriptiondesc').find('p').getText()
                # for a in soup.find('div', class_='movies-letter').find_all('a'):
                #     item = new_menu_item('Season %s' % a.getText(), 'video', a['href'], img=img)
                #     item.setInfo(type="video", infoLabels={'plot': plot})
            return

    source = soup.find('iframe')['src']
    js_mess = str(make_soup(source, raw=True))

    """
     Extracting mirrors
    """
    tcs = js_mess.index('var tc = ')
    tce = js_mess[tcs:].index('</script>')
    mirror_data = js_mess[tcs:tcs + tce]
    mirror_token = re.findall(r"\"_token\": \"([0-9A-Za-z].+)\"", mirror_data)[0]
    mirror_te = re.findall(r"var tc = '([0-9A-Za-z].+)'", mirror_data)[0]
    mirror_p = re.findall(r"\.slice\((\d+),(\d+)\).+\"(\d+)\"\+\"(\d+)\";", mirror_data)[0]
    mirror_xtoken = mirror_te[int(mirror_p[0]):int(mirror_p[1])][::-1] + mirror_p[2] + mirror_p[3]
    mirror_json = make_soup('https://gomostream.com/decoding_v3.php', raw=True,
                            params={
                                '_token': mirror_token,
                                'tokenCode': mirror_te
                            },
                            headers={
                                'x-token': mirror_xtoken
                            })
    xbmc.log("Token %s, TE: %s, xtoken: %s" % (mirror_token, mirror_te, mirror_xtoken), 4)
    mirrors = json.loads(mirror_json)
    for i, mirror in enumerate(mirrors):
        xbmc.log("Mirror %d: %s" % (i + 1, mirror), 4)
        title = "[COLOR red]Mirror %d [UNAVAILABLE][/COLOR]" % (i + 1)
        for available in VALID_SRC:
            if mirror.startswith(available):
                title = "Mirror %d" % (i + 1)
                break
        new_menu_item(title, 'play', mirror, playable=True)


def list_link(link=None, additional=None):
    listing = []
    if link is None:
        list_item = xbmcgui.ListItem(label="Search")
        listing.append((_url + "?action=search", list_item, True))
    xbmcplugin.addDirectoryItems(_handle, listing, len(listing))
    xbmcplugin.endOfDirectory(_handle)


def router(paramstring):
    xbmc.log("Router: " + paramstring, 4)
    params = dict(parse_qsl(paramstring))
    if params:
        if params['action'] == 'list':
            process_list(urllib2.unquote(params['link']))

        elif params['action'] == 'video':
            process_video(urllib2.unquote(params['link']))

        elif params['action'] == 'videoPlay':
            process_video(urllib2.unquote(params['link']), play=True)

        elif params['action'] == 'play':
            play_video(urllib2.unquote(params['link']))

        elif params['action'] == 'menu':
            for name, url in SUBMENUS.get(params['link'], []):
                item = xbmcgui.ListItem(label=name)
                MENU_ITEMS.append((url, item, True))

        elif params['action'] == 'find':
            text = xbmcgui.Dialog().input('Searching...')
            process_list(DOMAIN + '/topimdb?s=' + urllib.quote_plus(text.strip()))

    else:
        for name, url in MAIN_MENU:
            item = xbmcgui.ListItem(label=name)
            MENU_ITEMS.append((url, item, True))
    xbmcplugin.addDirectoryItems(_handle, MENU_ITEMS, len(MENU_ITEMS))
    xbmcplugin.endOfDirectory(_handle)


if __name__ == '__main__':
    try:
        router(sys.argv[2][1:])
    except urllib2.HTTPError as e:
        xbmcgui.Dialog().notification(_name, "Connection error {}".format(e.code))

    except urllib2.URLError as e:
        xbmcgui.Dialog().notification(_name, "Unable to connect", str(e.reason))

    except ssl.SSLError as e:
        if e.message == 'The read operation timed out':
            xbmcgui.Dialog().notification(_name, "Putlockers.co server timeout", "Try again later",
                                          icon=xbmcgui.NOTIFICATION_ERROR)
        else:
            xbmcgui.Dialog().notification(_name, "Connection error!", e.message)

    # except static.UpdateException as e:
    #     xbmcgui.Dialog().notification(_name, "Page error", e.message)
